From 4e65a4b17ac2958f21bbb620431aa13c07dc9683 Mon Sep 17 00:00:00 2001
From: Dmitri Pal <dpal@redhat.com>
Date: Tue, 4 Dec 2012 19:48:12 -0500
Subject: [PATCH 09/10] [INI] Update files used in the unit test

---
 Makefile.am               |    5 +-
 ini/ini.d/first.conf      |   25 ++
 ini/ini.d/mergecheck.conf |  592 +++++++++++++++++++++++++++++++++++++++++++++
 ini/ini.d/second.conf     |   28 +++
 ini/ini.d/sexpect.conf    |  115 +--------
 5 files changed, 659 insertions(+), 106 deletions(-)
 create mode 100644 ini/ini.d/first.conf
 create mode 100644 ini/ini.d/mergecheck.conf
 create mode 100644 ini/ini.d/second.conf

diff --git a/Makefile.am b/Makefile.am
index 8a48098c279a33c5ca1ae1c524f67634478f1f33..2b30cdcb70052786f4ebf73ef0f0369fd1085c40 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -255,7 +255,10 @@ dist_noinst_DATA += \
     ini/ini.d/foo.conf.in \
     ini/ini.d/mysssd.conf \
     ini/ini.d/smerge.conf \
-    ini/ini.d/sexpect.conf
+    ini/ini.d/sexpect.conf \
+    ini/ini.d/first.conf \
+    ini/ini.d/second.conf \
+    ini/ini.d/mergecheck.conf
 
 check_PROGRAMS += \
     ini_config_ut \
diff --git a/ini/ini.d/first.conf b/ini/ini.d/first.conf
new file mode 100644
index 0000000000000000000000000000000000000000..aed74e2ca984d31921776b280f3d6e1eac1de177
--- /dev/null
+++ b/ini/ini.d/first.conf
@@ -0,0 +1,25 @@
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+
+#END OF THE FIRST FILE
diff --git a/ini/ini.d/mergecheck.conf b/ini/ini.d/mergecheck.conf
new file mode 100644
index 0000000000000000000000000000000000000000..dce8b1a2922799fac4e783bad94294510986fd65
--- /dev/null
+++ b/ini/ini.d/mergecheck.conf
@@ -0,0 +1,592 @@
+# Section mode: MERGE, value mode: OVERWRITE
+[section_a]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 second multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 second multi value
+key2 = key2 second multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: MERGE, value mode: ERROR
+# This is an expected error 17 in mode 0 + 16 + 1
+
+# Section mode: MERGE, value mode: PRESERVE
+[section_a]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_c]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_b]
+key1 = key1 single value
+key2 = key2 single value
+key3 = key3 single value
+
+[section_d]
+key1 = second file, key1 single value
+key2 = second file, key2 single value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: MERGE, value mode: ALLOW
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: MERGE, value mode: DETECT
+# This is an expected error 17 in mode 0 + 64 + 4
+
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: ERROR, value mode: OVERWRITE
+# This is an expected error 17 in mode 256 + 0 + 0
+
+# Section mode: ERROR, value mode: ERROR
+# This is an expected error 17 in mode 256 + 16 + 1
+
+# Section mode: ERROR, value mode: PRESERVE
+# This is an expected error 17 in mode 256 + 32 + 2
+
+# Section mode: ERROR, value mode: ALLOW
+# This is an expected error 17 in mode 256 + 48 + 3
+
+# Section mode: ERROR, value mode: DETECT
+# This is an expected error 17 in mode 256 + 64 + 4
+
+# Section mode: OVERWRITE, value mode: OVERWRITE
+[section_a]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 second multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 second multi value
+key2 = key2 second multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: OVERWRITE, value mode: ERROR
+# This is an expected error 17 in mode 512 + 16 + 1
+
+# Section mode: OVERWRITE, value mode: PRESERVE
+[section_a]
+key1 = second file, key1 single value
+key2 = second file, key2 single value
+
+[section_c]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_b]
+key1 = key1 single value
+key2 = key2 single value
+key3 = key3 single value
+
+[section_d]
+key1 = second file, key1 single value
+key2 = second file, key2 single value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: OVERWRITE, value mode: ALLOW
+[section_a]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: OVERWRITE, value mode: DETECT
+# This is an expected error 17 in mode 512 + 64 + 4
+
+[section_a]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: PRESERVE, value mode: OVERWRITE
+[section_a]
+key1 = first file, key1 second multi value
+key2 = first file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 second multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 second multi value
+key2 = key2 second multi value
+
+[section_d]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: PRESERVE, value mode: ERROR
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: PRESERVE, value mode: PRESERVE
+[section_a]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_c]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_b]
+key1 = key1 single value
+key2 = key2 single value
+
+[section_d]
+key1 = second file, key1 single value
+key2 = second file, key2 single value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: PRESERVE, value mode: ALLOW
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: PRESERVE, value mode: DETECT
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: DETECT, value mode: OVERWRITE
+# This is an expected error 17 in mode 1024 + 0 + 0
+
+[section_a]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 second multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 second multi value
+key2 = key2 second multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 second multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: DETECT, value mode: ERROR
+# This is an expected error 17 in mode 1024 + 16 + 1
+
+# Section mode: DETECT, value mode: PRESERVE
+# This is an expected error 17 in mode 1024 + 32 + 2
+
+[section_a]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_c]
+key1 = first file, key1 single value
+key2 = first file, key2 single value
+
+[section_b]
+key1 = key1 single value
+key2 = key2 single value
+key3 = key3 single value
+
+[section_d]
+key1 = second file, key1 single value
+key2 = second file, key2 single value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: DETECT, value mode: ALLOW
+# This is an expected error 17 in mode 1024 + 48 + 3
+
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
+# Section mode: DETECT, value mode: DETECT
+# This is an expected error 17 in mode 1024 + 64 + 4
+
+[section_a]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_c]
+key1 = first file, key1 single value
+key1 = first file, key1 first multi value
+key1 = first file, key1 second multi value
+key2 = first file, key2 single value
+key2 = first file, key2 first multi value
+key2 = first file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE FIRST FILE
+
+#END OF THE SECOND FILE
diff --git a/ini/ini.d/second.conf b/ini/ini.d/second.conf
new file mode 100644
index 0000000000000000000000000000000000000000..a718f6e3b6a2aea12bf52897e510db2862fbe91c
--- /dev/null
+++ b/ini/ini.d/second.conf
@@ -0,0 +1,28 @@
+[section_a]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+[section_b]
+key1 = key1 single value
+key1 = key1 first multi value
+key1 = key1 second multi value
+key2 = key2 single value
+key2 = key2 first multi value
+key2 = key2 second multi value
+key3 = key3 single value
+key3 = key3 first multi value
+key3 = key3 second multi value
+
+[section_d]
+key1 = second file, key1 single value
+key1 = second file, key1 first multi value
+key1 = second file, key1 second multi value
+key2 = second file, key2 single value
+key2 = second file, key2 first multi value
+key2 = second file, key2 second multi value
+
+#END OF THE SECOND FILE
diff --git a/ini/ini.d/sexpect.conf b/ini/ini.d/sexpect.conf
index 93f7ed610b386961eb0e0056e54ccf7417f9f6d6..c962cc0d8108e244e8a4f86ef83fedee2887db17 100644
--- a/ini/ini.d/sexpect.conf
+++ b/ini/ini.d/sexpect.conf
@@ -17,21 +17,6 @@ key3 = section2b Value 3
 
 #End of file
 # Section mode: MERGE, value mode: ERROR
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: MERGE, value mode: PRESERVE
 [section1]
 # Key 1
@@ -111,85 +96,10 @@ key3 = section2b Value 3
 
 #End of file
 # Section mode: ERROR, value mode: OVERWRITE
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: ERROR, value mode: ERROR
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: ERROR, value mode: PRESERVE
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: ERROR, value mode: ALLOW
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: ERROR, value mode: DETECT
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: OVERWRITE, value mode: OVERWRITE
 [section1]
 # Key 1
@@ -296,6 +206,8 @@ key1 = section2a Value 1
 key2 = section2a Value 2
 # Key 3
 key3 = section2a Value 3
+
+#End of file
 # Section mode: PRESERVE, value mode: ERROR
 [section1]
 # Key 1
@@ -312,6 +224,8 @@ key1 = section2a Value 1
 key2 = section2a Value 2
 # Key 3
 key3 = section2a Value 3
+
+#End of file
 # Section mode: PRESERVE, value mode: PRESERVE
 [section1]
 # Key 1
@@ -328,6 +242,8 @@ key1 = section2a Value 1
 key2 = section2a Value 2
 # Key 3
 key3 = section2a Value 3
+
+#End of file
 # Section mode: PRESERVE, value mode: ALLOW
 [section1]
 # Key 1
@@ -344,6 +260,8 @@ key1 = section2a Value 1
 key2 = section2a Value 2
 # Key 3
 key3 = section2a Value 3
+
+#End of file
 # Section mode: PRESERVE, value mode: DETECT
 [section1]
 # Key 1
@@ -360,6 +278,8 @@ key1 = section2a Value 1
 key2 = section2a Value 2
 # Key 3
 key3 = section2a Value 3
+
+#End of file
 # Section mode: DETECT, value mode: OVERWRITE
 [section1]
 # Key 1
@@ -379,21 +299,6 @@ key3 = section2b Value 3
 
 #End of file
 # Section mode: DETECT, value mode: ERROR
-[section1]
-# Key 1
-key1 = section1a Value 1
-# Key 2
-key2 = section1a Value 2
-# Key 3
-key3 = section1a Value 3
-
-[section2]
-# Key 1
-key1 = section2a Value 1
-# Key 2
-key2 = section2a Value 2
-# Key 3
-key3 = section2a Value 3
 # Section mode: DETECT, value mode: PRESERVE
 [section1]
 # Key 1
-- 
1.7.1