>From acdf1a2085ebd0fd5b034502008a239f9a4b8837 Mon Sep 17 00:00:00 2001
From: Jiri Tomasek <jtomasek@redhat.com>
Date: Mon, 25 Jun 2012 15:06:55 +0200
Subject: [PATCH 10/12] Changed spec.in to include new symlinks and
 converge-ui files, fixed tests

---
 aeolus-conductor.spec.in                        |   10 ++++++----
 src/features/authentication.feature             |   10 +++++-----
 src/features/step_definitions/authentication.rb |    2 +-
 src/features/user.feature                       |    2 +-
 4 files changed, 13 insertions(+), 11 deletions(-)

diff --git a/aeolus-conductor.spec.in b/aeolus-conductor.spec.in
index 146ddb3..092414b 100644
--- a/aeolus-conductor.spec.in
+++ b/aeolus-conductor.spec.in
@@ -198,7 +198,8 @@ css="public/stylesheets public/stylesheets/jquery.ui-1.8.1"
 feature="features"
 gif="public/images \
      public/stylesheets/images \
-     vendor/converge-ui/images"
+     vendor/converge-ui/images \
+     vendor/converge-ui/images/icons"
 haml="app/views/hardware_profiles app/views/realm_mappings \
       app/views/users app/views/provider_accounts \
       app/views/roles app/views/providers app/views/settings \
@@ -356,9 +357,10 @@ popd 2>&1 > /dev/null
 
 #create converge-ui symlinks
 %{__ln_s} -f %{app_root}/vendor/converge-ui/rails/layouts %{app_root}/app/views/layouts/converge-ui
-%{__ln_s} -f %{app_root}/vendor/converge-ui/fonts %{app_root}/public/fonts/converge-ui
-%{__ln_s} -f %{app_root}/vendor/converge-ui/rails/helpers/layout_helper.rb %{app_root}/app/helpers/layout_helper.rb
-%{__ln_s} -f %{app_root}/vendor/converge-ui/javascripts/lib %{app_root}/public/javascripts/lib/converge-ui
+%{__ln_s} -f %{app_root}/vendor/converge-ui/fonts %{app_root}/public/fonts
+%{__ln_s} -f %{app_root}/vendor/converge-ui/images %{app_root}/public/images/converge-ui
+%{__ln_s} -f %{app_root}/vendor/converge-ui/rails/helpers %{app_root}/app/helpers/converge-ui
+%{__ln_s} -f %{app_root}/vendor/converge-ui/javascripts %{app_root}/public/javascripts/converge-ui
 
 %postun
 # kind of a weird construct.  There are two cases where postun gets called;
diff --git a/src/features/authentication.feature b/src/features/authentication.feature
index 98c130c..5fc5d07 100644
--- a/src/features/authentication.feature
+++ b/src/features/authentication.feature
@@ -13,7 +13,7 @@ Feature: User authentication
     Given I am a registered user
     And I am on the login page
     When I forget to enter my password
-    Then I should see "Login failed"
+    Then I should see "The Username or Password is incorrect"
     And I should be on the login error page
 
   Scenario: Edit profile
@@ -31,9 +31,9 @@ Feature: User authentication
     And I am logged in
     And I am on the root page
     When I follow "Log out"
-    Then I should see "Username:"
-    And I should see "Password:"
-    And I should see "Show my password"
+    Then I should see "Username"
+    And I should see "Password"
+    And I should see "Forgot Login or Password?"
 
   Scenario: Change user login to one with invalid length
     Given I am a registered user
@@ -49,5 +49,5 @@ Feature: User authentication
     Given I am a registered user
     And I am on the login page
     When I login with incorrect credentials
-    Then I should see "Login failed"
+    Then I should see "The Username or Password is incorrect"
     And I should be on the login error page
diff --git a/src/features/step_definitions/authentication.rb b/src/features/step_definitions/authentication.rb
index 1556400..418e7a3 100644
--- a/src/features/step_definitions/authentication.rb
+++ b/src/features/step_definitions/authentication.rb
@@ -26,7 +26,7 @@ def login(login, password)
   visit path_to("the login page")
   fill_in "login", :with => login
   fill_in "password", :with => password
-  click_button "login-btn"
+  click_button "login_btn"
 end
 
 def signup
diff --git a/src/features/user.feature b/src/features/user.feature
index 3fa6c8d..46e0b38 100644
--- a/src/features/user.feature
+++ b/src/features/user.feature
@@ -96,7 +96,7 @@ Feature: Manage Users
     Given there is a user "test"
     And I log out
     When I fill login "test" and incorrect password
-    Then I should see "Login failed"
+    Then I should see "The Username or Password is incorrect"
     When I login as authorised user
     And I go to test's user page
     Then "test" user failed login count is more than zero
-- 
1.7.7.6