diff -x '*.po' -d -urpN abrt.4/src/plugins/analyze_LocalGDB.xml.in abrt.5/src/plugins/analyze_LocalGDB.xml.in
--- abrt.4/src/plugins/analyze_LocalGDB.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/analyze_LocalGDB.xml.in	2012-04-04 17:08:29.628199084 +0200
@@ -6,4 +6,5 @@
     However, unlike RetraceServer, doesn't send coredump to remote machines.
     </_long-description>
     <creates-items>backtrace</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>
diff -x '*.po' -d -urpN abrt.4/src/plugins/analyze_RetraceServer.xml.in abrt.5/src/plugins/analyze_RetraceServer.xml.in
--- abrt.4/src/plugins/analyze_RetraceServer.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/analyze_RetraceServer.xml.in	2012-04-04 17:08:29.628199084 +0200
@@ -7,6 +7,7 @@
     Cons: coredump you upload contains all the data from the crashed program, including your private data, if any.
     </_long-description>
     <creates-items>backtrace</creates-items>
+    <gui-review-elements>no</gui-review-elements>
     <options>
         <option type="text" name="RETRACE_SERVER_URL">
            <_label>Retrace server URL</_label>
diff -x '*.po' -d -urpN abrt.4/src/plugins/analyze_VMcore.xml.in abrt.5/src/plugins/analyze_VMcore.xml.in
--- abrt.4/src/plugins/analyze_VMcore.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/analyze_VMcore.xml.in	2012-04-04 17:08:29.629198760 +0200
@@ -5,4 +5,5 @@
     <_long-description>Needs to install kernel debuginfo packages, which might take significant time, and take up disk space.
     </_long-description>
     <creates-items>backtrace</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>
diff -x '*.po' -d -urpN abrt.4/src/plugins/collect_GConf.xml.in abrt.5/src/plugins/collect_GConf.xml.in
--- abrt.4/src/plugins/collect_GConf.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/collect_GConf.xml.in	2012-04-04 17:08:29.629198760 +0200
@@ -4,4 +4,5 @@
     <_description>Save configuration from application's GConf directory</_description>
     <_long-description>Runs gconftool-2 --recursive-list /apps/executable and saves it as 'gconf_subtree' element.</_long-description>
     <creates-items>gconf_subtree</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>
diff -x '*.po' -d -urpN abrt.4/src/plugins/collect_Smolt.xml.in abrt.5/src/plugins/collect_Smolt.xml.in
--- abrt.4/src/plugins/collect_Smolt.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/collect_Smolt.xml.in	2012-04-04 17:08:29.629198760 +0200
@@ -6,4 +6,5 @@
     Runs smoltSendProfile -p and saves its output as 'smolt_data' element.
     </_long-description>
     <creates-items>smolt_data</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>
diff -x '*.po' -d -urpN abrt.4/src/plugins/collect_vimrc_system.xml.in abrt.5/src/plugins/collect_vimrc_system.xml.in
--- abrt.4/src/plugins/collect_vimrc_system.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/collect_vimrc_system.xml.in	2012-04-04 17:08:29.629198760 +0200
@@ -4,4 +4,5 @@
     <_description>Save /etc/vimrc and /etc/gvimrc</_description>
     <_long-description>Checks if there are vimrc and gvimrc files in /etc and saves them as system_vimrc and system_gvimrc, respectively.</_long-description>
     <creates-items>system_vimrc,system_gvimrc</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>
diff -x '*.po' -d -urpN abrt.4/src/plugins/collect_vimrc_user.xml.in abrt.5/src/plugins/collect_vimrc_user.xml.in
--- abrt.4/src/plugins/collect_vimrc_user.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/collect_vimrc_user.xml.in	2012-04-04 17:08:29.629198760 +0200
@@ -4,4 +4,5 @@
     <_description>Save .vimrc and .gvimrc from your home directory</_description>
     <_long-description>Checks if there are .vimrc and .gvimrc in your home directory and saves them as user_vimrc and user_gvimrc, respectively.</_long-description>
     <creates-items>user_vimrc,user_gvimrc</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>
diff -x '*.po' -d -urpN abrt.4/src/plugins/collect_xsession_errors.xml.in abrt.5/src/plugins/collect_xsession_errors.xml.in
--- abrt.4/src/plugins/collect_xsession_errors.xml.in	2012-03-26 14:18:03.000000000 +0200
+++ abrt.5/src/plugins/collect_xsession_errors.xml.in	2012-04-04 17:08:29.629198760 +0200
@@ -7,4 +7,5 @@
     The result is saved as 'xsession_errors' element.
     </_long-description>
     <creates-items>xsession_errors</creates-items>
+    <gui-review-elements>no</gui-review-elements>
 </event>